package cn.iocoder.yudao.module.mes.service.ticketmanagement;

import java.util.*;
import javax.validation.*;

import cn.iocoder.yudao.module.mes.controller.admin.dashboard.vo.dashboard.EventStatisticsVO;
import cn.iocoder.yudao.module.mes.controller.admin.ticketmanagement.vo.*;
import cn.iocoder.yudao.module.common.dal.dataobject.moldticketmanagement.MoldTicketManagementDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.ticketmanagement.TicketManagementDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.module.mes.dal.dataobject.ticketresults.TicketResultsDO;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * 项目方案关联 Service 接口
 *
 * @author 内蒙必硕
 */
public interface TicketManagementService {

    /**
     * 创建项目方案关联
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createTicketManagement(@Valid TicketManagementSaveReqVO createReqVO);

    /**
     * 更新项目方案关联
     *
     * @param updateReqVO 更新信息
     */
    void updateTicketManagement(@Valid TicketManagementSaveReqVO updateReqVO);

    /**
     * 删除项目方案关联
     *
     * @param id 编号
     */
    void deleteTicketManagement(Long id);

    /**
     * 获得项目方案关联
     *
     * @param id 编号
     * @return 项目方案关联
     */
    TicketManagementDO getTicketManagement(Long id);

    /**
     * 获得项目方案关联分页
     *
     * @param pageReqVO 分页查询
     * @return 项目方案关联分页
     */
    PageResult<TicketManagementDO> getTicketManagementPage(TicketManagementPageReqVO pageReqVO);

    void batchUpdateJobStatus(@Valid TicketManagementBatchUpdateReqVO reqVO);

    List<TicketResultsDO> getInspectionByDeviceId(Long id,String startTime,String endTime,String ids);

    List<TicketResultsDO> getMaintenanceByDeviceId(Long id,String startTime,String endTime,String ids);

    Long getBaoyangListCountByJobStatus();

    Long getDianjianListCountByJobStatus();

    List<TicketManagementDO> getListByJobStatus();

    void selectCountDeviceInspection(EventStatisticsVO eventStatisticsVO);

    void selectCountDeviceMaintenance(EventStatisticsVO eventStatisticsVO);

    List<TicketManagementDO> getList();
}